//
// MA_RSI_BB.mq4                                                             . 
//      RSI    MetaQuotes Software Corp.
//     . RSI    . 
//  BB     RSI.
//  , , sk@autograf.dp.ua, ICQ 64015987, http://autograf.dp.ua
// 0 
#property copyright "Copyright SK AutoGraf  2008"
#property link      "http://autograf.dp.ua/"

#property indicator_separate_window             //    
#property indicator_minimum 0                   //  
#property indicator_maximum 100                 //  
#property indicator_buffers 6                   //   6
//================================================================================== 1 ==
#property indicator_color1 DodgerBlue           //   RSI
 
extern int MA_period= 2;                        //   (   Close,  )
extern int RSIPeriod=14;                        //    RSI
extern int Level_1 = 70;                        //  1
extern int Level_2 = 30;                        //  2

double RSIBuffer[];                             //     RSI
double PosBuffer[];                             //  
double NegBuffer[];                             //  
//---------------------------------------------------------------------------------- 2 --
#property indicator_color4 Aqua                 //    
#property indicator_color5 White                //    
#property indicator_color6 LimeGreen            //    

extern int    BandsPeriod=20;                   //    
extern double K_Dev=1.5;                        //  .   

double Up_Buffer[];                             //      
double MovingBuffer[];                          //      
double Dn_Buffer[];                             //      
// 3 
int init()
   {
//================================================================================== 4 ==
   string short_name="MA_RSI_BB("+MA_period+","+RSIPeriod+","+BandsPeriod+","+K_Dev+")";
   IndicatorShortName(short_name);              //   
   SetLevelValue(1, Level_1);                   //   1
   SetLevelValue(2, Level_2);                   //   2
//---------------------------------------------------------------------------------- 5 --
   SetIndexStyle(0,DRAW_LINE);                  //  
   SetIndexBuffer(0,RSIBuffer);                 //     . 
   SetIndexDrawBegin(0,RSIPeriod);              //    RSI

   SetIndexBuffer(1,PosBuffer);                 //     . 
   SetIndexBuffer(2,NegBuffer);                 //     . 
//---------------------------------------------------------------------------------- 6 --
   SetIndexStyle(3,DRAW_LINE);                  //  
   SetIndexBuffer(3,Up_Buffer);                 //     . 
   SetIndexDrawBegin(3,BandsPeriod);            //     BB

   SetIndexStyle(4,DRAW_LINE);                  //  
   SetIndexBuffer(4,MovingBuffer);              //     . 
   SetIndexDrawBegin(4,BandsPeriod);            //     BB

   SetIndexStyle(5,DRAW_LINE);                  //  
   SetIndexBuffer(5,Dn_Buffer);                 //     . 
   SetIndexDrawBegin(5,BandsPeriod);            //     BB
//================================================================================== 7 ==
   return;
   }
// 8 
int start()
   {
//================================================================================== 9 ==
   if(Bars<=RSIPeriod || Bars<=MA_period || Bars<=BandsPeriod) //   
      return;                                   // 

   int counted_bars=IndicatorCounted();         //   
   int i=Bars-counted_bars-1;                   //    
//--------------------------------------------------------------------------------- 10 --
   while(i>=0)                                  //    
      {
      double sumn=0.0,sump=0.0;                 //  
      double MA_n = iMA(NULL, 0, MA_period, 0, MODE_SMMA, PRICE_CLOSE, i);//  
      double MA_n1= iMA(NULL, 0, MA_period, 0, MODE_SMMA, PRICE_CLOSE, i+1);// 
      double rel = MA_n - MA_n1;                //  

      if(rel>0) sump=rel;                       //  
      else      sumn=-rel;                      //  
      double  positive=(PosBuffer[i+1]*(RSIPeriod-1)+sump)/RSIPeriod;//   
      double  negative=(NegBuffer[i+1]*(RSIPeriod-1)+sumn)/RSIPeriod;//  . RSI

      PosBuffer[i]=positive;                    // .      
      NegBuffer[i]=negative;                    // .      
      if(negative==0.0) RSIBuffer[i]=0.0;       //    0  . RSI
      else RSIBuffer[i]=100.0-100.0/(1+positive/negative);//  RSI
//--------------------------------------------------------------------------------- 11 --
      MovingBuffer[i]= 50;                      //   -  
//    MovingBuffer[i]= RSIBuffer[i];            // 2  -  = RSI
      double sum=0.0;                           // . 
      int k = i+BandsPeriod-1;                  //     
      while(k>=i)                               //   .   .
         {
         double newres = RSIBuffer[k] - MovingBuffer[i]; // 
         sum += newres*newres;                           //   
         k--;
         }
      double deviation=K_Dev*MathSqrt(sum/BandsPeriod);  //  
      Up_Buffer[i]= MovingBuffer[i] + deviation;//  
      Dn_Buffer[i]= MovingBuffer[i] - deviation;//  
      i--;
      }
//================================================================================= 12 ==
   return;
   }
//    13 